;-------------------------------------------------------------------------------
; Hogyan írjunk játékot ZX Spectrumra...
; 3. fejezet - Hanghatások
;-------------------------------------------------------------------------------
; Példaprogram 3.3 - Fehér zaj
;-------------------------------------------------------------------------------
; Az alábbi rutin egy hangeffekten alapul az Egghead 3-ból. 
;-------------------------------------------------------------------------------
; SjAsmPlus v1.07rc verzióval fordítva
;-------------------------------------------------------------------------------

	DEVICE ZXSPECTRUM48

; ide fordítjuk a kódot (32768)
	.org $8000

; címke az sjasmplus számára a kódhossz számításához
start:

noise	ld	e, 250		; ismétlés 250-szer
	ld	hl, 0		; kezdő mutató a ROM-ban
noise2	push	de
	ld	b, 32		; lépés mértéke
noise0	push	bc
	ld	a, (hl)		; következő "véletlen" szám
	inc	hl		; mutató
	and	248		; fekete keretet szeretnénk
	out	(254), a	; hangszóróra ki
	ld	a, e		; ahogy e értéke csökken...
	cpl			; ...növeljük a várakozást
noise1	dec	a		; csökkentjük a ciklus számlálót
	jr	nz, noise1	; várakozó ciklus
	pop	bc
	djnz	noise0		; következő lépés
	pop	de
	ld	a, e
	sub	24		; lépés mérete
	cp	30		; tartomány vége
	ret	z
	ret	c
	ld	e, a
	cpl
noise3	ld	b, 40		; csend
noise4	djnz	noise4
	dec	a
	jr	nz, noise3
	jr	noise2

	ret

; címke az sjasmplus számára a kódhossz számításához
end:

; a lefordított bináris kódot elmenti
	.savebin "pelda_3_3.bin",start,end-start   
